/*
 * Functions for the buffer manager execute functions
 *
 *	17-JUL-1992	KEK	Masaharu NOMACHI
 *
 */

#include "bm.h"
#include "bm_exec.h"
#include "bm_config.h"

/*************************
 * process list handling *
 *************************/

/*
 *  put the process just after the process
 *  which has higher or equal priority.
 */
int put_process(top,process) struct EXEC_process **top, *process; {
    struct EXEC_process *p,*q;

    q = *top;
    if (q==NULL_process) {
	*top = process;
	p = process; q = process;
    }
    else if (process->priority > q->priority) {
	*top = process;
	p = q->previous;
    }
    else {
	p = q->previous;
	while(process->priority > p->priority) p = p->previous;
	q = p->next;
    }

    /*
     *  Insert the "process" in between p and q
     *      (p->q ==> p->process->q)
     */
    process->next     = q;
    process->previous = p;
    p->next     = process;
    q->previous = process;
    return 0;
}

int remove_process(top,process) struct EXEC_process **top, *process; {
    struct EXEC_process *p,*q;

    p = process->previous;
    q = process->next;
    if (process == *top) *top = q;
    if (process == *top) *top = NULL_process;
    p->next     = q;
    q->previous = p;
    return 0;
}

/************************
 * buffer list handling *
 ************************/

put_buffer(top,buffer) struct EXEC_buffer **top, *buffer; {
    struct EXEC_buffer *tail, *head;

    head = *top;
    if (head == NULL_buffer) {
	*top = buffer;
	buffer->next     = buffer;
	buffer->previous = buffer;
    }
    else {
	tail = head->previous;
	tail->next       = buffer;
	buffer->next     = head;
	head->previous   = buffer;
	buffer->previous = tail;
    }
    return 0;
}

append_buffer(top,list) struct EXEC_buffer **top, *list; {
    struct EXEC_buffer *tail, *head, *first, *last;

    if (list==NULL_buffer) return 0;
    head = *top;
    if (head == NULL_buffer) *top = list;
    else {
	tail = head->previous;
	first = list;
	last = first->previous;
	tail->next      = first;
	last->next      = head;
	head->previous  = last;
	first->previous = tail;
    }
    return 0;
}

struct EXEC_buffer *get_buffer(top) struct EXEC_buffer **top; {
    struct EXEC_buffer *buffer;

    buffer = *top;
    if (buffer != NULL_buffer) {
	*top = buffer->next;
	if (buffer == *top) *top = NULL_buffer;
	buffer->next->previous = buffer->previous;
	buffer->previous->next = buffer->next;
    }
    return buffer;
}

    
