%{
#include <string.h>
#include "y.tab.h"

struct element {
	char *name;
	struct element *next;
	};

extern char hexstring[], octstring[], decstring[], groupstring[];
extern char keystring[], txtstring[], idstring[],sevstring[];
extern char helpfile[],commentstring[];
extern char inputline[];
extern struct element *currentkeyword;

extern void upcpy();
extern int  yywrap();
extern int  atoi();
extern int yyback();
extern int yylook();
%}

%%
0x[0-9a-fA-F]+ { strcat(inputline,yytext);
		 sscanf(yytext,"0x%x",&yylval.int_val);
		 return HEXNUMB; }

0X[0-9a-fA-F]+ { strcat(inputline,yytext);
		 sscanf(yytext,"0X%X",&yylval.int_val);
		 return HEXNUMB; }

0[0-7]+	{ strcat(inputline,yytext);strcpy(octstring, &yytext[2]);
		 sscanf(yytext,"0%d",&yylval.int_val);
		 return OCTNUMB; }

[0-9]+		{ strcat(inputline,yytext);
		 yylval.int_val = atoi(yytext);
	         return DECNUMB; }

\#.*\n	{ strcat(inputline,yytext);strcpy(commentstring, yytext); 
	  yylval.char_ptr = commentstring; return COMMENT;}

[iIwWeEsS]+	{ strcat(inputline,yytext);upcpy(sevstring, &yytext[0]);
		  yylval.char_ptr = sevstring;return SEVERITY;}

\-[a-zA-Z]+     { strcat(inputline,yytext);upcpy(keystring, &yytext[0]); 
		 addtolist(currentkeyword,keystring);
		 currentkeyword = currentkeyword->next;
	         yylval.char_ptr=currentkeyword->name;
	         if (strncmp(keystring, "-END",strlen(keystring))== 0) 
			return(ENDMARKER);
		 else
			return KEYWORD; }

[\$a-zA-Z][\$\_a-zA-Z0-9]* 
	{  strcat(inputline,yytext);
	   if ( (strlen(keystring) >0) &&
		(strncmp(keystring,"-GROUPS",strlen(keystring)) == 0))
	   {
	      strcpy(groupstring,yytext); 
	      yylval.char_ptr = groupstring;
	      return GROUP; 
	   }
	   else 
	   {
	      strcpy(idstring,yytext); 
	      yylval.char_ptr = idstring;
	      return ID; 
	   }}

[\/]?[\.\/\_\$a-zA-Z0-9]* { strcat(inputline,yytext);
	   if ( (strlen(keystring) >0) && 
		(strncmp(keystring,"-HELP",strlen(keystring)) == 0))
	   {
	      strcpy(helpfile,yytext);
	      yylval.char_ptr = helpfile;
	      return HFILE;
	   }
	   else
	   {
	      printf("oops... what's this -%s?\n",yytext);
	   }}

[\\][ \t]*\n	{ strcat(inputline,yytext); 
	  strcat(inputline,"              ");
	  nstr = yylook(); 
	  goto yyfussy; /*continuation get nex token */}

\<.*\>	{ strcat(inputline,yytext);strcpy(txtstring, yytext);
	  yylval.char_ptr = txtstring;  return TEXT; }
\".*\"	{ strcat(inputline,yytext);strcpy(txtstring, yytext); 
  	  yylval.char_ptr = txtstring; return TEXT; }
\'.*\'	{ strcat(inputline,yytext);strcpy(txtstring, yytext);
	  yylval.char_ptr =txtstring;  return TEXT; }
\(.*\)	{ strcat(inputline,yytext);strcpy(txtstring, yytext); 
          yylval.char_ptr = txtstring; return TEXT; }
\/.*\/	{ strcat(inputline,yytext);strcpy(txtstring, yytext); 
          yylval.char_ptr = txtstring;return TEXT; }
\{.*\}	{ strcat(inputline,yytext);strcpy(txtstring, yytext);
          yylval.char_ptr = txtstring; return TEXT; }
\[.*\]	{ strcat(inputline,yytext);strcpy(txtstring, yytext); 
          yylval.char_ptr = txtstring; return TEXT; }

[ \t]+			{ strcat(inputline,yytext); /* skip blanks */}
\n	{ /*strcat(inputline,yytext); */
	 yytext[0] = '\0';
	 return(ENDMARKER);/* skip new lines */}
