      program murmur_convert
*
*  murmur_con.f
*
*  Program to take the output of the murmur message program, which was run
*  with the sdc_pack.msg file as input, and output a translations file
*  of error number to printed message.
*
*  The assumption with all messages is that the text is enclosed within
*  < > pairs, and that only string descriptors (at most) are used.
*

*************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
*************************************************************************

      character*90 line
      character*8 mnum
      character*200 istor
*
      open (unit=17, file='mess.list', status='unknown')
 1    continue
      read (5,'(a)',end=999) line
      jl = lenocc(line)
      if (line(1:1) .eq. '#') go to 1
      if (line(1:4) .eq. '8019') then
*
*  This is a the beginning of a line with a murmur message number.  Now
*  look for the message as well.
*
         mnum = line(1:8)
         istrt = index(line,'<') + 1
         iend = index(line,'>')
         if (iend .eq. 0) then
            istor = line(istrt:jl)
 2          read(5,'(a)') line
            jl2 = lenocc(line)
            iend = index(line,'>')
            if (iend .eq. 0) then
               istor(jl+1:jl+jl2) = line(1:jl2)
               jl = jl+jl2
               go to 2
            else
               istor(jl+1:jl+jl2-1) = line(1:jl2-1)
            end if
         else
            istor = line(istrt:iend-1)
         end if
         write(17,'(''0x'',a,1x,a)') mnum, istor(1:lenocc(istor))
      end if
      go to 1
*
 999  continue
      end

      INTEGER FUNCTION LENOCC(STR)
      IMPLICIT NONE

      CHARACTER*(*) STR
      INTEGER I

      DO I = LEN(STR), 1, -1
         IF (STR(I:I) .NE. ' ') THEN
            LENOCC = I
            RETURN
         ENDIF
      ENDDO

      LENOCC = 0

      RETURN
      END
