/*************************************************
 * ipc_msg_clnt.c,v
*************************************************/
/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include <rpc/rpc.h>
#ifndef VXWORKS
#include <sys/time.h>
#endif
#include "ipc_msg.h"

#ifdef hpux

#ifndef NULL
#define NULL  0
#endif  NULL

#endif hpux

static struct timeval TIMEOUT = { 25, 0 };

int *
sendmessage_1(argp, clnt)
	char **argp;
	CLIENT *clnt;
{
	static int res;

#ifdef VXWORKS
        bzero((char *)&res, sizeof(res));
#else
	memset(&res, 0, sizeof(res));
#endif
	if (clnt_call(clnt, SENDMESSAGE, xdr_wrapstring, argp, xdr_int, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


int *
checkprocess_1(argp, clnt)
	char **argp;
	CLIENT *clnt;
{
	static int res;

#ifdef VXWORKS
        bzero((char *)&res, sizeof(res));
#else
	memset(&res, 0, sizeof(res));
#endif
	if (clnt_call(clnt, CHECKPROCESS, xdr_wrapstring, argp, xdr_int, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


int *
startprocess_1(argp, clnt)
	char **argp;
	CLIENT *clnt;
{
	static int res;

#ifdef VXWORKS
        bzero((char *)&res, sizeof(res));
#else
	memset(&res, 0, sizeof(res));
#endif
	if (clnt_call(clnt, STARTPROCESS, xdr_wrapstring, argp, xdr_int, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


struct rsp_ret *
readsp_1(argp, clnt)
	struct rsp_send *argp;
	CLIENT *clnt;
{
	static struct rsp_ret res;

#ifdef VXWORKS
        bzero((char *)&res, sizeof(res));
#else
	memset(&res, 0, sizeof(res));
#endif
	if (clnt_call(clnt, READSP, xdr_rsp_send, argp, xdr_rsp_ret, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


struct rsp_ret_all *
readspall_1(argp, clnt)
	struct rsp_send_all *argp;
	CLIENT *clnt;
{
	static struct rsp_ret_all res;

#ifdef VXWORKS
        bzero((char *)&res, sizeof(res));
#else
	memset(&res, 0, sizeof(res));
#endif
	if (clnt_call(clnt, READSPALL, xdr_rsp_send_all, argp, xdr_rsp_ret_all, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

