      /*
       *  msg_proc.c: implementation of the remote procedure "printmessage"
       */

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include <stdio.h>
#include <rpc/rpc.h>        /*  always needed */
#include "ipc_msg.h"      /* need this too: ipc_msg.h will be generated by 
                             rpcgen */
#include "tmpltsym.h"
#include "template.h"

int Table_connect;

#ifdef VXWORKS
myboot()
{
  taskDelay(10);
  reboot();
}
#endif

int *sendmessage_1(msg)
char **msg;
{
  static int result;  /* must be static! */
  char dest[100],mess[800],mes[800];
  
  strcpy(mes,*msg);
/*  printf("Entering sendmessage\n"); */
  if(Table_connect != 1) {
/*    printf("Trying to connect to the table\n"); */
    link_to_sp();
    if(Attach_Table() < 0) result = -1;
    else                  Table_connect = 1;
  }
  Parse(mes,dest,mess);
/*  printf("Server dest !!%s!!\nServer mess !!%s!!\n",dest,mess); */
#ifdef VXWORKS
  if(strcmp(dest,"server") == 0 && strcmp(mess," reboot") == 0){
    result = 1;
    sp(myboot,0,0,0,0,0,0,0,0,0);
    return(&result);
  }
#endif
  result = send_to_single(dest,mess);
/*  printf("Server Result of sending %d\n",result);  */
  return (&result);
}

int *checkprocess_1(name)
char **name;
{
  static int result;  /* must be static! */
  char dest[100],mess[800],mes[800];
  Table entry;
  int index;
  char hnam[100];
  
/*  printf("Entering checkprocess\n"); */
  if(Table_connect != 1) {
/*    printf("Trying to connect to the table\n"); */
    link_to_sp();
    if(Attach_Table() < 0) {
      result = -1;
      return(&result);
    }
    else                  Table_connect = 1;
  }
  index = Search_Table(*name);
  if(index < 0) {
    result = 0;
    return(&result);
  }
  Read_from_Table(&entry,index);
  gethostname(hnam,100);
  if((strncmp(hnam,entry.node,strlen(hnam)) == 0) ||
     (entry.node[0] == '\0') ) {
    if(entry.status != DEAD) result = 1;
    else                     result = 0;
  }
  else result = 0;
  return (&result);
}

int *startprocess_1(name)
char **name;
{
  strcat(*name," &");
#ifdef VXWORKS
  vxsystem(*name);
#else
  system(*name);
#endif
  return(0);
}

struct rsp_ret *readsp_1(rs)
struct rsp_send *rs;
{
  static struct rsp_ret result;
  short tpe;
  int size;
  char val[150];

  xdr_free(xdr_rsp_ret,(char *)&result);
  result.type = -1;
  if(Table_connect != 1) {
    link_to_sp();
    if(Attach_Table() < 0) result.rtcode = -1;
    else                  Table_connect = 1;
  }
  result.rtcode = sp_read_value(rs->procname,rs->varname,
				&tpe,val);
  result.type = tpe;
  if(tpe == INTEGER)     memcpy(&(result.i_val),val,sizeof(int));
  else if(tpe == REAL)   memcpy(&(result.f_val),val,sizeof(float));
  else if(tpe == STRING) strcpy(result.s_val,val);
  return(&result);
}

struct rsp_ret_all *readspall_1(rs)
struct rsp_send_all *rs;
{
  static struct rsp_ret_all result;
  int n_var,i,i_off;
  short tpe[100];
  char varname[5000];
  char value[5000];

  xdr_free(xdr_rsp_ret_all,(char *)&result);
  result.rtcode = -1;
  if(Table_connect != 1) {
    link_to_sp();
    if(Attach_Table() < 0) result.rtcode = -1;
    else                  Table_connect = 1;
  }
  result.rtcode = sp_read_all_values(rs->procname,varname,rs->varsize,tpe,
				value,rs->valsize,&n_var);
  for(i=0;i<n_var;i++){
    result.type[i] = tpe[i];
    i_off = i*(rs->valsize);
    if(tpe[i] == INTEGER)     
      memcpy(&(result.i_val[i]),&(value[i_off]),sizeof(int));
    else if(tpe[i] == REAL)   
      memcpy(&(result.f_val[i]),&(value[i_off]),sizeof(float));
    else if(tpe[i] == STRING) 
      strcpy(&(result.s_val[i_off]),&(value[i_off]));
  }
  memcpy(result.varname,varname,5000);
  result.n_var = n_var;
  return(&result);
}
