/*************************************************
 * status.c,v
*************************************************/
/*---------------------------------------------------------------*/
/*                                                               */
/*      Cengiz ERBAS                                             */
/*      Superconducting Super Collider Laboratory                */
/*      June 20, 1992                                            */
/*                                                               */
/*---------------------------------------------------------------*/

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <errno.h>
#include "template.h"
#include "ask.h"

int event_semid;  /* Delete later. */ 


/*(a+out) ------------------------------------------------- */
#ifdef VXWORKS
Status(argv1,argv2,argv3,argv4,argv5,argv6,argv7,
     argv8,argv9,argv10) 
char *argv1,*argv2,*argv3,*argv4,*argv5,*argv6,*argv7,*argv8,*argv9,*argv10;
{
  char *argv[] = {NULL,argv1,argv2,argv3,argv4,argv5,argv6,argv7,argv8,
		    argv9,argv10}; 
  int argc = 11;
#else
main(argc, argv)
int argc;
char * argv[];
{
#endif
/*(b+out)------------------------------------------------- 
Procedure Name
Main - main status-keeping procedure
Synopsis
Description
main(argc, argv) is the main status-keeping procedure. It
calls the template with the addresses of the Any_Event() and
Process_Event() procedures.

Superconducting Super Collider Laboratory 1.0
(c+out) --------------------------------------------------- */

   int num,i;
   Table prt_table[TABLE_SIZE];
   char cstatus[10];

#ifdef VXWORKS
   argv[0] = "status";
   for(i=0;i<11;i++) {
     if(argv[i] == NULL) {
       argc = i+1;
       break;
     }
   }
#endif
   if (Attach_Table() == -1)
      printf("No such table\n");
   else {
      printf("\n");
      num = Get_Table(prt_table); 
      printf("  process_name         node           pid    msgqid   status\n");
      printf("--------------   ----------------    -----   ------   ------\n");
      for (i=0;i<num;i++) {
	 prt_table[i].node[16] = '\0';
         if (prt_table[i].status == ALIVE)     strcpy(cstatus, "ALIVE");
         else if (prt_table[i].status == DEAD) strcpy(cstatus, "DEAD");
	 else                                  strcpy(cstatus,"BUSY");
         printf(" %13s    %16s   %5d   %5d     %s\n", prt_table[i].process_name
		,prt_table[i].node, prt_table[i].process_id, 
		 prt_table[i].msgq_id, cstatus);
      }

   }

}

