/*---------------------------------------------------------------*/
/*                                                               */
/*      pipe.c                                                   */
/*                                                               */
/*      Superconducting Super Collider Laboratory                */
/*      July 20, 1992                                            */
/*                                                               */
/*---------------------------------------------------------------*/

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include <stdio.h>
#include "template.h"
#include "to_pipe.h"
#include <errno.h>

#include "nova.h"
#define NOVA_HOSTNAME_MAX  32    /*  extracted from novanet.h   */
#define DEFAULT_NAME     "/tmp/nova"
#define DEFAULT_PRI      10 
#define DEFAULT_SLEEP    1

#define  NTIMEOUT       0

int Process_Event();

struct   NOVAD *nd;
int *data, length;
FILE *fp = NULL;

FILE *fptr = NULL;

/*(a+out) ------------------------------------------------- */
main(argc, argv)
int argc;
char * argv[];
/*(b+out) -------------------------------------------------
Procedure Name
Main - main procedure of to_pipe
Synopsis
Description
main(argc, argv) is the main procedure of the 

Superconducting Super Collider Laboratory 1.0
(c+out) --------------------------------------------------- */

{
   char name[NV_MAXNAME + 1];
   char sec_name[NV_MAXNAME + NOVA_HOSTNAME_MAX + 1];
   int new_pri = 0; 

   if(Template_Init(get_name_from_args(argc,argv)) < 0){
     printf("Process of name %s already exists\n",
            get_name_from_args(argc,argv));
     printf("Please use -n to set a different name\n");
     exit(0);
   }

   /*
    *   Open NOVA
    */
   UNI_nova_parms(DEFAULT_NAME, DEFAULT_PRI, name, sec_name);
   if ((int)(nd = (struct NOVAD *)UNI_nova_open(name, nova_prio, 1)) == -1) {
       if (debug_level >= 10) printf("to_pipe: cannot open %s", name);
       Send_Message ( ownpname, "EXIT" );
   }

   Template_Main((int (*)())Process_Event, NULL, NULL, NULL);
}


/*(a+out) ------------------------------------------------- */
int Process_Event()
/*(b+out) -------------------------------------------------
Procedure Name
Process_Event -Synopsis
Description

Superconducting Super Collider Laboratory 1.0
(c+out) --------------------------------------------------- */

{
   int status;
   int i, pos = 0, post[2];
   int len, lenwrt;
   char y[6];
      
   for (i = 0; i<6; i++) y[i] = '9';
   
   status = UNI_nova_get(nd, &data, &length);
   if (status != 0) return (FALSE);

   fwrite(y, sizeof(char), 6, stdout); 
   while (data[pos] != 0) {
      len = data[pos];
      for (i= pos; i <len+pos; i++);
      pos = i;
   }  
   pos++;
   post[0] = pos;
   
   lenwrt = fwrite((char *)post, sizeof(int), 1,stdout); 
   
   lenwrt = fwrite((char *)data, sizeof(int), post[0], stdout);
   
   if (lenwrt != post[0]) {
      printf("\n\nERROR in to_pipe\n\n");
      exit(1);
   }

   UNI_nova_put(nd,data,length,0);
   return TRUE;
   
}

int ExitR(header, arg_string)
char *header, *arg_string;
{
   fclose(fptr);
   
   UNI_nova_close(nd);
   Exit("analyzer", " ");    
}
