/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#if !defined(SGI) && !defined(VXWORKS)
#include "camlib.h"
#endif

#define INTREG 5

static int period = 0;

#if defined(SGI) || defined(VXWORKS)

camac_init(max_length) int *max_length; {}
camac_event(mode, max_length,event_length,buf)
int *mode, *event_length, *max_length, *buf; { }
camac_begin (run_type) int *run_type; {}
camac_end (run_type) int *run_type; {}
camac_pause (mode) int *mode; {}
camac_resume (mode) int *mode; {}

#else

camac_init( max_lengthP )
int *max_lengthP;       /* max length in 4 byte words for event */
{ 
  *max_lengthP = 150;   /* modify here to return different max_length */
  return 0;
}

camac_event(mode, max_length,event_length,buf)
int *mode;
int *event_length;
int *max_length;
int *buf;
{ 
   return (0);
}



camac_begin(run_type)
int *run_type;
{   
   int dat,q,x,mask;

   /*
    * Open and Initialize CAMAC 
    */
   CAMOPN();
   CSETBR(1);
   CSETCR(0);
   CGENC();
   CGENZ();
   CREMI();
   CAM_DisableLAM();

   return;
}




camac_pause(mode)
int *mode;
{ 
   int dat, q, x, mask;
 
   CAM_DisableLAM();
   return;
}



camac_resume(mode)
int *mode;
{  
   int mask; int dat,q,x;

   /*
    * Initialize CAMAC 
    */
   mask = 1 << (INTREG - 1);
   CAM_EnableLAM(mask);

   return;
}



camac_end(run_type)
int *run_type;
{     

   CAM_DisableLAM();
   CAM_Close();

   return;
}

#endif
